> For the complete documentation index, see [llms.txt](https://docs.petabox.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.petabox.io/http-api-compatible-with-amazon-s3/api-reference/uploadpartcopy.md).

# UploadPartCopy

You specify the data source by adding the request header `x-amz-copy-source` in your request and a byte range by adding the request header `x-amz-copy-source-range` in your request.

{% hint style="info" %}
**Note**

Instead of using an existing object as part data, you might use the [UploadPart](/http-api-compatible-with-amazon-s3/api-reference/multipart-upload/uploadpart.md) action and provide data in your request.
{% endhint %}

You must initiate a multipart upload before you can upload any part. In response to your initiate request. Petabox returns a unique identifier, the upload ID, that you must include in your upload part request.

Note the following additional considerations about the request headers `x-amz-copy-source-if-match`, `x-amz-copy-source-if-none-match`, `x-amz-copy-source-if-unmodified-since`, and `x-amz-copy-source-if-modified-since`:

* **Consideration 1** - If both of the `x-amz-copy-source-if-match` and `x-amz-copy-source-if-unmodified-since` headers are present in the request as follows:

  `x-amz-copy-source-if-match` condition evaluates to `true`, and;

  `x-amz-copy-source-if-unmodified-since` condition evaluates to `false`;

  Petabox returns `200 OK` and copies the data.
* **Consideration 2** - If both of the `x-amz-copy-source-if-none-match` and `x-amz-copy-source-if-modified-since` headers are present in the request as follows:

  `x-amz-copy-source-if-none-match` condition evaluates to `false`, and;

  `x-amz-copy-source-if-modified-since` condition evaluates to `true`;

  Petabox returns `412 Precondition Failed` response code.

### Versioning

If your bucket has versioning enabled, you could have multiple versions of the same object. By default, `x-amz-copy-source` identifies the current version of the object to copy. If the current version is a delete marker and you don't specify a versionId in the `x-amz-copy-source`, Petabox returns a 404 error, because the object does not exist. If you specify versionId in the `x-amz-copy-source` and the versionId is a delete marker, Petabox returns an HTTP 400 error, because you are not allowed to specify a delete marker as a version for the `x-amz-copy-source`.

You can optionally specify a specific version of the source object to copy by adding the `versionId` subresource as shown in the following example:

`x-amz-copy-source: /bucket/object?versionId=version id`

### Special errors

* ***Code:** NoSuchUpload*

  ***Cause**: The specified multipart upload does not exist. The upload ID might be invalid, or the multipart upload might have been aborted or completed.    **HTTP*** ***Status Code**: 404 Not Found*
* ***Code:** InvalidRequest*

  ***Cause:** The specified copy source is not supported as a byte-range copy source.*

  ***HTTP Status Code:** 400 Bad Request*

## Request Syntax <a href="#api_uploadpartcopy_requestsyntax" id="api_uploadpartcopy_requestsyntax"></a>

```http
PUT /Key+?partNumber=PartNumber&uploadId=UploadId HTTP/1.1
Host: Bucket.s3.petabox.io
x-amz-copy-source: CopySource
x-amz-copy-source-if-match: CopySourceIfMatch
x-amz-copy-source-if-modified-since: CopySourceIfModifiedSince
x-amz-copy-source-if-none-match: CopySourceIfNoneMatch
x-amz-copy-source-if-unmodified-since: CopySourceIfUnmodifiedSince
x-amz-copy-source-range: CopySourceRange
x-amz-server-side-encryption-customer-algorithm: SSECustomerAlgorithm
x-amz-copy-source-server-side-encryption-customer-algorithm: CopySourceSSECustomerAlgorithm
x-amz-request-payer: RequestPayer
x-amz-expected-bucket-owner: ExpectedBucketOwner
x-amz-source-expected-bucket-owner: ExpectedSourceBucketOwner
```

## URI Request Parameters <a href="#api_uploadpartcopy_requestparameters" id="api_uploadpartcopy_requestparameters"></a>

The request uses the following URI parameters.

#### Bucket

The bucket name.

Required: Yes

#### Key

Object key for which the multipart upload was initiated.

Length Constraints: Minimum length of 1.

Required: Yes

#### partNumber

Part number of part being copied. This is a positive integer between 1 and 10,000.

Required: Yes

#### uploadId

Upload ID identifying the multipart upload whose part is being copied.

Required: Yes

#### x-amz-copy-source

Specifies the source object for the copy operation. You specify the value in one of two formats, depending on whether you want to access the source object through an access point:

* For objects not accessed through an access point, specify the name of the source bucket and key of the source object, separated by a slash (/). For example, to copy the object `reports/january.pdf` from the bucket `awsexamplebucket`, use `awsexamplebucket/reports/january.pdf`. The value must be URL-encoded.
* For objects accessed through access points, specify the Amazon Resource Name (ARN) of the object as accessed through the access point, in the format `arn:aws:s3:<Region>:<account-id>:accesspoint/<access-point-name>/object/<key>`. For example, to copy the object `reports/january.pdf` through access point `my-access-point` owned by account `123456789012` in Region `us-west-2`, use the URL encoding of `arn:aws:s3:us-west-2:123456789012:accesspoint/my-access-point/object/reports/january.pdf`. The value must be URL encoded.

{% hint style="info" %}
**Note**

Petabox supports copy operations using access points only when the source and destination buckets are in the same Region.
{% endhint %}

To copy a specific version of an object, append `?versionId=<version-id>` to the value (for example, `petaboxexamplebucket/reports/january.pdf?versionId=QUpfdndhfd8438MNFDN93jdnJFkdmqnh893`. If you don't specify a version ID, Petabox copies the latest version of the source object.

Pattern: `\/.+\/.+`

Required: Yes

#### x-amz-copy-source-if-match

Copies the object if its entity tag (ETag) matches the specified tag.

#### x-amz-copy-source-if-modified-since

Copies the object if it has been modified since the specified time.

#### x-amz-copy-source-if-none-match

Copies the object if its entity tag (ETag) is different than the specified ETag.

#### x-amz-copy-source-if-unmodified-since

Copies the object if it hasn't been modified since the specified time.

#### x-amz-copy-source-range

The range of bytes to copy from the source object. The range value must use the form bytes=first-last, where the first and last are the zero-based byte offsets to copy. For example, bytes=0-9 indicates that you want to copy the first 10 bytes of the source. You can copy a range only if the source object is greater than 5 MB.

#### x-amz-copy-source-server-side-encryption-customer-algorithm

Specifies the algorithm to use when decrypting the source object (for example, AES256).

#### x-amz-copy-source-server-side-encryption-customer-key

Not supported at the moment.

#### x-amz-copy-source-server-side-encryption-customer-key-MD5

Not supported at the moment.

#### x-amz-expected-bucket-owner

The account ID of the expected destination bucket owner. If the destination bucket is owned by a different account, the request fails with the HTTP status code `403 Forbidden` (access denied).

#### x-amz-request-payer

Confirms that the requester knows that they will be charged for the request. Bucket owners need not specify this parameter in their requests.&#x20;

Valid Values: `requester`

#### x-amz-server-side-encryption-customer-algorithm

Specifies the algorithm to use to when encrypting the object (for example, AES256).

#### x-amz-server-side-encryption-customer-key

Not supported at the moment.

#### x-amz-server-side-encryption-customer-key-MD5

Not supported at the moment.

#### x-amz-source-expected-bucket-owner

The account ID of the expected source bucket owner. If the source bucket is owned by a different account, the request fails with the HTTP status code `403 Forbidden` (access denied).

## Request Body <a href="#api_uploadpartcopy_requestbody" id="api_uploadpartcopy_requestbody"></a>

The request does not have a request body.

## Response Syntax <a href="#api_uploadpartcopy_responsesyntax" id="api_uploadpartcopy_responsesyntax"></a>

```http
HTTP/1.1 200
x-amz-copy-source-version-id: CopySourceVersionId
x-amz-server-side-encryption: ServerSideEncryption
x-amz-server-side-encryption-customer-algorithm: SSECustomerAlgorithm
x-amz-request-charged: RequestCharged
<?xml version="1.0" encoding="UTF-8"?>
<CopyPartResult>
   <ETag>string</ETag>
   <LastModified>timestamp</LastModified>
   <ChecksumCRC32>string</ChecksumCRC32>
   <ChecksumCRC32C>string</ChecksumCRC32C>
   <ChecksumSHA1>string</ChecksumSHA1>
   <ChecksumSHA256>string</ChecksumSHA256>
</CopyPartResult>
```

## Response Elements <a href="#api_uploadpartcopy_responseelements" id="api_uploadpartcopy_responseelements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The response returns the following HTTP headers.

#### x-amz-copy-source-version-id

The version of the source object that was copied, if you have enabled versioning on the source bucket.

#### x-amz-request-charged

If present, indicates that the requester was successfully charged for the request.

Valid Values: `requester`

#### x-amz-server-side-encryption

The server-side encryption algorithm used when storing this object in Petabox (for example, AES256, `aws:kms`).

Valid Values: `AES256 | aws:kms`

#### x-amz-server-side-encryption-aws-kms-key-id

Not supported at the moment.

#### x-amz-server-side-encryption-bucket-key-enabled

Not supported at the moment.

#### x-amz-server-side-encryption-customer-algorithm

If server-side encryption with a customer-provided encryption key was requested, the response will include this header confirming the encryption algorithm used.

#### x-amz-server-side-encryption-customer-key-MD5

Not supported at the moment.

#### CopyPartResult

Root level tag for the CopyPartResult parameters.

Required: Yes

#### ChecksumCRC32

Not supported at the moment.

#### ChecksumCRC32C

Not supported at the moment.

#### ChecksumSHA1

Not supported at the moment.

#### ChecksumSHA256

Not supported at the moment.

#### ETag

Entity tag of the object.

Type: String

#### LastModified

Date and time at which the object was uploaded.

Type: Timestamp

## Examples <a href="#api_uploadpartcopy_examples" id="api_uploadpartcopy_examples"></a>

### Sample Request <a href="#api_uploadpartcopy_example_1" id="api_uploadpartcopy_example_1"></a>

The following PUT request uploads a part (part number 2) in a multipart upload. The request specifies a byte range from an existing object as the source of this upload. The request includes the upload ID that you get in response to your Initiate Multipart Upload request.

```http
PUT /newobject?partNumber=2&uploadId=VCVsb2FkIElEIGZvciBlbZZpbmcncyBteS1tb3ZpZS5tMnRzIHVwbG9hZR HTTP/1.1
Host: target-bucket.s3.<Region>.petabox.io
Date:  Mon, 11 Apr 2011 20:34:56 GMT
x-amz-copy-source: /source-bucket/sourceobject
x-amz-copy-source-range:bytes=500-6291456
Authorization: authorization string
```

### Sample Response <a href="#api_uploadpartcopy_example_2" id="api_uploadpartcopy_example_2"></a>

The response includes the ETag value. You need to retain this value to use when you send the Complete Multipart Upload request.

```http
HTTP/1.1 200 OK
x-amz-id-2: Vvag1LuByRx9e6j5Onimru9pO4ZVKnJ2Qz7/C1NPcfTWAtRPfTaOFg==
x-amz-request-id: 656c76696e6727732072657175657374
Date:  Mon, 11 Apr 2011 20:34:56 GMT
Server: Petabox 

<CopyPartResult>
   <LastModified>2011-04-11T20:34:56.000Z</LastModified>
   <ETag>"9b2cf535f27731c974343645a3985328"</ETag>
</CopyPartResult>
```

### Sample Request <a href="#api_uploadpartcopy_example_3" id="api_uploadpartcopy_example_3"></a>

The following PUT request uploads a part (part number 2) in a multipart upload. The request does not specify the optional byte range header, but requests the entire source object copy as part 2. The request includes the upload ID that you got in response to your Initiate Multipart Upload request.

```http
PUT /newobject?partNumber=2&uploadId=VCVsb2FkIElEIGZvciBlbZZpbmcncyBteS1tb3ZpZS5tMnRzIHVwbG9hZR HTTP/1.1
Host: target-bucket.s3.<Region>.petabox.io
Date:  Mon, 11 Apr 2011 20:34:56 GMT
x-amz-copy-source: /source-bucket/sourceobject?versionId=3/L4kqtJlcpXroDTDmJ+rmSpXd3dIbrHY+MTRCxf3vjVBH40Nr8X8gdRQBpUMLUo
Authorization: authorization string
```

### Sample Response <a href="#api_uploadpartcopy_example_4" id="api_uploadpartcopy_example_4"></a>

The response includes the ETag value. You need to retain this value to use when you send the Complete Multipart Upload request.

```http
HTTP/1.1 200 OK
x-amz-id-2: Vvag1LuByRx9e6j5Onimru9pO4ZVKnJ2Qz7/C1NPcfTWAtRPfTaOFg==
x-amz-request-id: 656c76696e6727732072657175657374
x-amz-copy-source-version-id: 3/L4kqtJlcpXroDTDmJ+rmSpXd3dIbrHY+MTRCxf3vjVBH40Nr8X8gdRQBpUMLUo
Date:  Mon, 11 Apr 2011 20:34:56 GMT
Server: Petabox 

<CopyPartResult>
   <LastModified>2011-04-11T20:34:56.000Z</LastModified>
   <ETag>"9b2cf535f27731c974343645a3985328"</ETag>
</CopyPartResult>
```
